Package net.sf.saxon.om

## Enum SequenceIterator.Property

- java.lang.Object
- - java.lang.Enum<SequenceIterator.Property>
  - - net.sf.saxon.om.SequenceIterator.Property

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<SequenceIterator.Property>`
  Enclosing interface:
    SequenceIterator

      public static enum SequenceIterator.Property
      extends java.lang.Enum<SequenceIterator.Property>

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `ATOMIZING` | Property value: the iterator can deliver an atomized result.
    `GROUNDED` | Property value: the iterator is "grounded".
    `LAST_POSITION_FINDER` | Property value: the iterator knows the number of items that it will deliver.
    `LOOKAHEAD` | Property value: the iterator knows whether there are more items still to come.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static SequenceIterator.Property` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static SequenceIterator.Property[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### GROUNDED

          public static final SequenceIterator.Property GROUNDED

      Property value: the iterator is "grounded". This means that (a) the iterator must be an instance of `GroundedIterator`, and (b) the implementation of the materialize() method must be efficient (in particular, it should not involve the creation of new objects)

    - #### LAST_POSITION_FINDER

          public static final SequenceIterator.Property LAST_POSITION_FINDER

      Property value: the iterator knows the number of items that it will deliver. This means that (a) the iterator must be an instance of `LastPositionFinder`, and (b) the implementation of the getLastPosition() method must be efficient (in particular, it should take constant time, rather than time proportional to the length of the sequence)

    - #### LOOKAHEAD

          public static final SequenceIterator.Property LOOKAHEAD

      Property value: the iterator knows whether there are more items still to come. This means that (a) the iterator must be an instance of `LookaheadIterator`, and (b) the implementation of the hasNext() method must be efficient (more efficient than the client doing it)

    - #### ATOMIZING

          public static final SequenceIterator.Property ATOMIZING

      Property value: the iterator can deliver an atomized result. This means that the iterator must be an instance of `AtomizingIterator`.

  - ### Method Detail

    - #### values

          public static SequenceIterator.Property[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (SequenceIterator.Property c : SequenceIterator.Property.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static SequenceIterator.Property valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null